#include <stdlib.h>
#include <stdio.h>

#define CGAIN (0.95)

main()
{
	float Y,I,Q,R,G,B;
	int y,i,q,j,r,g,b;
	FILE *fp;
	
	int colortab[128];
	
	for (j=0;j<128;j++) colortab[j]=0;
	
	for (y=0;y<2;y++) {
		for (i=0;i<5;i++) {
			for (q=0;q<5;q++){
				Y=y; //(y*4+abs(i-2)+abs(q-2))/8.0;
				Y=y + ((y==0)?(abs(i-2)+abs(q-2))*0.125*CGAIN : 0);
				I=(i-2)*0.5957/2.0*CGAIN;
				Q=(q-2)*0.5226/2.0*CGAIN;
				
				R=Y+0.956*I+0.621*Q;
				G=Y-0.272*I-0.647*Q;
				B=Y-1.106*I+1.703*Q;
				j=q|(i<<3)|(y<<6);
				
				printf("%f %f %f %f %f %f ->",Y,I,Q,R,G,B);
				
				r=R*16+0.5; if (r>15) r=15; if (r<0) r=0;
				g=G*16+0.5; if (g>15) g=15; if (g<0) g=0;
				b=B*16+0.5; if (b>15) b=15; if (b<0) b=0;
				colortab[j]=(r<<8)|(g<<4)|b;
				
				printf("%x %x %x %03x\n",y,i,q,colortab[j]);
			}
		}
	}
	
	if ((fp=fopen("iqcolor.hex","w"))==NULL) exit(1);
	
	for (j=0;j<128;j++) fprintf(fp,"%03x\n",colortab[j]);
	fclose(fp);

}
