#include <stdlib.h>
#include <stdio.h>
#include <string.h>


#define ROMBASE	(0) 		//0xE000 & 0x1F00)
#define ROMSIZE (0x2000)

unsigned char mem[ROMSIZE];

main(int argc, char **argv)
{
	int i,n;
	FILE *fp;

	memset(mem,0xff,ROMSIZE);
	
	if ((fp=fopen(argv[1],"rb"))==NULL) exit(1);
	n=fread(mem,1,ROMSIZE,fp);
	fclose(fp);

	if (argc>3) n=atoi(argv[3]); 

	if ((fp=fopen(argv[2],"wb"))==NULL) exit(1);
	//fprintf(fp,"@%04X\n",ROMBASE);
	for (i=0;i<n;i++) fprintf(fp,"%02X\n",mem[i]);
	fclose(fp);
	return 0;
}

